diff --git a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
new file mode 100644
index 000000000..20c98a49d
--- /dev/null
+++ b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
@@ -0,0 +1,302 @@
+package net.minecraft.client.world.chunk.provider;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.world.ProgressListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.*;
+import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+
+import java.io.IOException;
+import java.util.*;
+
+public class ChunkProviderDynamic implements IChunkProvider
+{
+    private final Set<Integer> droppedChunksSet;
+    private final Chunk emptyChunk;
+    public ChunkGenerator chunkGenerator;
+    private final IChunkLoader chunkLoader;
+    private final Map<Integer, Chunk> chunkMap;
+    private final Map<Integer, Chunk> forceLoadedChunkMap;
+    private final List<Chunk> forceLoadedChunkList;
+    private final World world;
+    private int currentChunkX;
+    private int currentChunkZ;
+    public int forceLoadedChunksLimit = 64;
+    public int maxUnloadPerTick = 10;
+    private int lastQueriedChunkXPos;
+    private int lastQueriedChunkZPos;
+    private Chunk lastQueriedChunk;
+
+    public ChunkProviderDynamic(World world, IChunkLoader chunkLoader, ChunkGenerator chunkGenerator)
+    {
+        droppedChunksSet = new HashSet<>();
+        chunkMap = new HashMap<>();
+        forceLoadedChunkList = new ArrayList<>();
+        forceLoadedChunkMap = new HashMap<>();
+        emptyChunk = new EmptyChunk(world, 0, 0);
+        this.world = world;
+        this.chunkLoader = chunkLoader;
+        this.chunkGenerator = chunkGenerator;
+    }
+
+    @Override
+    public boolean isChunkLoaded(int chunkX, int chunkZ) {
+        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
+        if(canChunkBeUnloaded(chunkX, chunkZ)) {
+            if(chunkMap.containsKey(id)) droppedChunksSet.add(id);
+            return false;
+        }
+        Chunk chunk = chunkMap.get(id);
+        return chunk == emptyChunk || (chunk != null && chunk.isAtLocation(chunkX, chunkZ));
+    }
+
+    public boolean canChunkBeUnloaded(int chunkX, int chunkZ) {
+        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
+        if(forceLoadedChunkMap.containsKey(id)) return false;
+        int renderDistance = Minecraft.getMinecraft(this).gameSettings.renderDistance.value.chunks;
+        return chunkX <= currentChunkX - renderDistance || chunkZ <= currentChunkZ - renderDistance || chunkX >= currentChunkX + renderDistance || chunkZ >= currentChunkZ + renderDistance;
+    }
+
+    @Override
+    public Chunk provideChunk(int chunkX, int chunkZ) {
+        if(chunkX == lastQueriedChunkXPos && chunkZ == lastQueriedChunkZPos && lastQueriedChunk != null)
+        {
+            return lastQueriedChunk;
+        }
+        if(!world.findingSpawnPoint && canChunkBeUnloaded(chunkX, chunkZ)) return emptyChunk;
+        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
+        if(!isChunkLoaded(chunkX, chunkZ)) {
+            if(chunkMap.get(id) != null){
+                Chunk chunk = chunkMap.get(id);
+                saveChunk(chunk);
+                chunk.onUnload();
+            }
+            Chunk chunk = loadChunk(chunkX, chunkZ);
+            if(chunk == null)
+            {
+                if (chunkGenerator != null)
+                {
+                    chunk = chunkGenerator.generate(chunkX, chunkZ);
+                    chunk.fixMissingBlocks();
+                }
+                else
+                {
+                    chunk = emptyChunk;
+                }
+            }
+            chunkMap.put(id, chunk);
+            chunk.onLoad();
+            if(chunk.isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
+            {
+                populate(this, chunkX, chunkZ);
+            }
+            if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
+            {
+                populate(this, chunkX - 1, chunkZ);
+            }
+            if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
+            {
+                populate(this, chunkX, chunkZ - 1);
+            }
+            if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
+            {
+                populate(this, chunkX - 1, chunkZ - 1);
+            }
+            if (world.getCurrentWeather() != null)
+            {
+                world.getCurrentWeather().doChunkLoadEffect(world, chunk);
+            }
+        }
+        lastQueriedChunkXPos = chunkX;
+        lastQueriedChunkZPos = chunkZ;
+        lastQueriedChunk = chunkMap.get(id);;
+        return chunkMap.get(id);
+    }
+
+    @Override
+    public Chunk prepareChunk(int chunkX, int chunkZ) {
+        return provideChunk(chunkX, chunkZ);
+    }
+
+    @Override
+    public void regenerateChunk(int chunkX, int chunkZ)
+    {
+        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
+        droppedChunksSet.remove(id);
+        chunkMap.remove(id);
+        Chunk chunk;
+        if (chunkGenerator != null)
+        {
+            chunk = chunkGenerator.generate(chunkX, chunkZ);
+            chunk.fixMissingBlocks();
+        }
+        else return;
+        chunkMap.put(id, chunk);
+        if(!chunk.isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
+        {
+            populate(this, chunkX, chunkZ);
+        }
+        if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
+        {
+            populate(this, chunkX - 1, chunkZ);
+        }
+        if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
+        {
+            populate(this, chunkX, chunkZ - 1);
+        }
+        if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
+        {
+            populate(this, chunkX - 1, chunkZ - 1);
+        }
+    }
+
+    @Override
+    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ)
+    {
+        Chunk chunk = provideChunk(chunkX, chunkZ);
+        if(!chunk.isTerrainPopulated)
+        {
+            chunk.isTerrainPopulated = true;
+            if (this.chunkGenerator != null)
+            {
+                this.chunkGenerator.decorate(chunk);
+                chunk.setChunkModified();
+            }
+        }
+    }
+
+    public boolean keepLoaded(int chunkX, int chunkZ) {
+        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
+        Chunk chunk = chunkMap.get(id);
+        if(isChunkLoaded(chunkX, chunkZ) && !forceLoadedChunkMap.containsKey(id) && forceLoadedChunkList.size() < forceLoadedChunksLimit) {
+            forceLoadedChunkMap.put(id, chunk);
+            forceLoadedChunkList.add(chunk);
+            return true;
+        }
+        return false;
+    }
+
+    public boolean removeFromForceLoaded(int chunkX, int chunkZ){
+        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
+        forceLoadedChunkList.remove(forceLoadedChunkMap.get(id));
+        return forceLoadedChunkMap.remove(id) != null;
+    }
+
+    @Override
+    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate)
+    {
+        int attempts = 0;
+        int chunksToBeSaved = 0;
+        if(progressUpdate != null)
+        {
+            for (Chunk chunk : chunkMap.values()) {
+                if(chunk != null && chunk.needsSaving(saveImmediately)) chunksToBeSaved++;
+            }
+        }
+        int progress = 0;
+        for (Chunk chunk : chunkMap.values()) {
+            if(chunk == null) continue;
+            if(!chunk.needsSaving(saveImmediately)) continue;
+            saveChunk(chunk);
+            chunk.isModified = false;
+            if(++attempts == 2 && !saveImmediately) return false;
+            if(progressUpdate != null && ++progress % 10 == 0) progressUpdate.progressStagePercentage((progress * 100) / chunksToBeSaved);
+        }
+        return true;
+    }
+
+    private void saveChunk(Chunk chunk)
+    {
+        if(chunkLoader == null) return;
+        try
+        {
+            chunk.lastSaveTime = world.getWorldTime();
+            chunkLoader.saveChunk(world, chunk);
+        }
+        catch(IOException ioexception)
+        {
+            ioexception.printStackTrace();
+        }
+    }
+
+    private Chunk loadChunk(int i, int j)
+    {
+        if(chunkLoader == null) return emptyChunk;
+        try
+        {
+            Chunk chunk = chunkLoader.loadChunk(world, i, j);
+            if(chunk != null)
+            {
+                chunk.lastSaveTime = world.getWorldTime();
+            }
+            return chunk;
+        }
+        catch(Exception exception)
+        {
+            exception.printStackTrace();
+        }
+        return emptyChunk;
+    }
+
+    @Override
+    public boolean tick() {
+        int dropped = 0;
+        for (Chunk chunk : chunkMap.values()) {
+            if(dropped >= maxUnloadPerTick) break;
+            if(!isChunkLoaded(chunk.xPosition,chunk.zPosition)){
+                break;
+            } //droppedChunksSet gets updated as side-effect
+        }
+        if(!droppedChunksSet.isEmpty()){
+            int unloaded = 0;
+            HashSet<Integer> copy = new HashSet<>(droppedChunksSet);
+            for (int i : copy) {
+                if(unloaded >= maxUnloadPerTick) break;
+                if(forceLoadedChunkMap.containsKey(i)) continue;
+                if(chunkMap.containsKey(i)){
+                    Chunk chunk = chunkMap.get(i);
+                    chunk.onUnload();
+                    saveChunk(chunk);
+                    chunkMap.remove(i);
+                    droppedChunksSet.remove(i);
+                    unloaded++;
+                } else {
+                    droppedChunksSet.remove(i);
+                }
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public boolean canSave() {
+        return true;
+    }
+
+    public IChunkLoader getChunkLoader() {
+        return chunkLoader;
+    }
+
+    @Override
+    public String getInfoString() {
+        return "Chunks: " + chunkMap.size() + ", " + "Dropped: " + droppedChunksSet.size()+", "+"Chunkloaded: "+forceLoadedChunkMap.size()+"/"+forceLoadedChunksLimit;
+    }
+
+    @Override
+    public void unloadAllChunks() {
+        for (Chunk chunk : chunkMap.values()) {
+            if(chunk != null) chunk.onUnload();
+        }
+        chunkMap.clear();
+        droppedChunksSet.clear();
+        chunkGenerator = null;
+        System.gc();
+    }
+
+    @Override
+    public void setCurrentChunkOver(int chunkX, int chunkZ) {
+        currentChunkX = chunkX;
+        currentChunkZ = chunkZ;
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
index a01d7f5e9..2d4bc69bc 100644
--- a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
@@ -1,17 +1,18 @@
 package net.minecraft.core.block;
 
+import java.util.Random;
+
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.block.LeavesBlockItem;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.season.Season;
 
-import java.util.Random;
-
 // Referenced classes of package net.minecraft.src:
 //            Block, IBlockAccess, Material
 
@@ -26,7 +27,6 @@ public abstract class BaseLeavesBlock extends Block
     {
         super(key, namespaceId, id, material);
         setTicking(true);
-        setBlockItem(() -> new LeavesBlockItem(this));
     }
 
     @Override
@@ -213,6 +213,11 @@ public abstract class BaseLeavesBlock extends Block
     	}
     }
     
+    @Override
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    	return LeavesLayerBlock.MASK_PERMANENT;
+    }
+    
     @Override
     public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
     	return enableTreeShadowing ? 0.8f : 0.0f;
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index c39cf79a9..23e918c3f 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -1,46 +1,48 @@
 package net.minecraft.core.block;
 
 
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.LinkedHashMap;
+import java.util.Map;
+import java.util.Random;
+import java.util.function.Function;
+import java.util.function.Supplier;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 import com.b100.utils.Utils;
+
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.material.MaterialColor;
-import net.minecraft.core.entity.ItemEntity;
-import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.block.BlockItem;
-import net.minecraft.core.sound.BlockSound;
-import net.minecraft.core.sound.BlockSounds;
-import net.minecraft.core.util.HardIllegalArgumentException;
-import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IItemConvertible;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.ToolShearsItem;
+import net.minecraft.core.item.block.BlockItem;
+import net.minecraft.core.sound.BlockSound;
+import net.minecraft.core.sound.BlockSounds;
+import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
-
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.LinkedHashMap;
-import java.util.Map;
-import java.util.Random;
-import java.util.function.Function;
-import java.util.function.Supplier;
 
 public class Block
     implements ITaggable<Block>, IItemConvertible
@@ -696,6 +698,11 @@ public class Block
     {
         return blockMaterial.getPushReaction();
     }
+    
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
+    {
+    	return 0;
+    }
 
     public static boolean isBuried (World world, int x, int y, int z)
     {
diff --git a/src/main/java/net/minecraft/core/block/FlowerBlock.java b/src/main/java/net/minecraft/core/block/FlowerBlock.java
index 14b31fc1d..c72f1999f 100644
--- a/src/main/java/net/minecraft/core/block/FlowerBlock.java
+++ b/src/main/java/net/minecraft/core/block/FlowerBlock.java
@@ -1,19 +1,18 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.entity.Mob;
+import java.util.Random;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-import java.util.Random;
-
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, GrassBlock,
 //            AxisAlignedBB
@@ -44,11 +43,10 @@ public class FlowerBlock extends Block implements IBonemealable
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side placeSide, Mob mob, double sideHeight) {
-        if (mob instanceof Player){
-            world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | 0b1000_0000); // Set persistent flag
-        }
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    	return LeavesLayerBlock.MASK_PERMANENT;
     }
+    
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
diff --git a/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java b/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
index 26e5c1cbf..a597b3867 100644
--- a/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
@@ -2,19 +2,24 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material
-
 public class PaintedPlanksBlock extends Block
 {
     public PaintedPlanksBlock(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.wood);
     }
+    
+    @Override
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
+    {
+    	return stack.getMetadata();
+    }
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
diff --git a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
index 3865612f6..f96d247af 100644
--- a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -11,6 +13,11 @@ public class PaintedSlabBlock extends SlabBlock
 	{
 		super(modelBlock, namespaceId, id);
 	}
+	
+	@Override
+	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+		return stack.getMetadata();
+	}
 
 	@Override
 	public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
diff --git a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
index 58eaeb004..c2aac8276 100644
--- a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
@@ -54,12 +54,18 @@ public class FurnaceBlockEntity extends BlockEntity
             {
                 ItemStack itemstack = furnaceItemStacks[index];
                 furnaceItemStacks[index] = null;
+                if (index == 2) {
+                    worldObj.markBlockNeedsUpdate(x, y, z);
+                }
                 return itemstack;
             }
             ItemStack itemstack1 = furnaceItemStacks[index].splitStack(takeAmount);
             if(furnaceItemStacks[index].stackSize <= 0)
             {
                 furnaceItemStacks[index] = null;
+                if (index == 2) {
+                    worldObj.markBlockNeedsUpdate(x, y, z);
+                }
             }
             return itemstack1;
         } else
@@ -76,6 +82,9 @@ public class FurnaceBlockEntity extends BlockEntity
         {
             itemstack.stackSize = getMaxStackSize();
         }
+        if (index == 2 && itemstack == null) {
+            worldObj.markBlockNeedsUpdate(x, y, z);
+        }
     }
 
     @Override
@@ -272,6 +281,7 @@ public class FurnaceBlockEntity extends BlockEntity
                 }
             }
         }
+        boolean wasEmpty = furnaceItemStacks[2] == null;
         if(furnaceItemStacks[2] == null && itemstack != null)
         {
             furnaceItemStacks[2] = itemstack.copy();
@@ -284,6 +294,9 @@ public class FurnaceBlockEntity extends BlockEntity
         {
             furnaceItemStacks[0] = null;
         }
+        if (wasEmpty && furnaceItemStacks[2] != null) {
+            worldObj.markBlockNeedsUpdate(x, y, z);
+        }
     }
 
     protected void updateFurnace(){
@@ -312,7 +325,7 @@ public class FurnaceBlockEntity extends BlockEntity
         // Do nothing
     }
 
-    protected ItemStack furnaceItemStacks[];
+    protected ItemStack[] furnaceItemStacks;
     public int maxBurnTime;
     public int currentCookTime;
     public int maxCookTime;
diff --git a/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
index ea4582340..142107b20 100644
--- a/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
@@ -1,13 +1,16 @@
 package net.minecraft.core.block.piston;
 
+import java.util.ArrayList;
+
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.logic.PistonDirections;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.block.PistonBlockItem;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -15,8 +18,6 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-import java.util.ArrayList;
-
 public class BasePistonBlock extends Block
 {
 
@@ -24,7 +25,6 @@ public class BasePistonBlock extends Block
     {
         super(key, namespaceId, id, Material.piston);
         this.isSticky = isSticky;
-        setBlockItem(() -> new PistonBlockItem(this));
         withHardness(0.5F);
     }
 
@@ -389,6 +389,11 @@ public class BasePistonBlock extends Block
 
         return true;
     }
+    
+    @Override
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    	return 7;
+    }
 
     private boolean isSticky;
     
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index 7bc1ce125..b474f0da8 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -174,12 +174,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
     {
         return maxStackSize;
     }
-
-    public int getPlacedBlockMetadata(int i)
-    {
-        return 0;
-    }
-
+    
     public boolean getHasSubtypes()
     {
         return hasSubtypes;
diff --git a/src/main/java/net/minecraft/core/item/PaintingItem.java b/src/main/java/net/minecraft/core/item/PaintingItem.java
index d5bf9bcdc..3f1f78338 100644
--- a/src/main/java/net/minecraft/core/item/PaintingItem.java
+++ b/src/main/java/net/minecraft/core/item/PaintingItem.java
@@ -65,7 +65,8 @@ public class PaintingItem extends Item
             }
             world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
             itemstack.consumeItem(entityplayer);
+            return true;
         }
-        return true;
+        return false;
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/PebbleItem.java b/src/main/java/net/minecraft/core/item/PebbleItem.java
index 69ded824f..8e4a8538b 100644
--- a/src/main/java/net/minecraft/core/item/PebbleItem.java
+++ b/src/main/java/net/minecraft/core/item/PebbleItem.java
@@ -115,14 +115,13 @@ public class PebbleItem
         // Regular placement, as all else fails
         if (world.canBlockBePlacedAt(Blocks.OVERLAY_PEBBLES.id, blockX, blockY, blockZ, false, side) && world.isBlockOpaqueCube(blockX, blockY - 1, blockZ))
         {
-            final Block block = Blocks.OVERLAY_PEBBLES;
-            if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, getPlacedBlockMetadata(itemstack.getMetadata())))
+            if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, 0))
             {
                 Blocks.OVERLAY_PEBBLES.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
                 world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(entityplayer);
+				return true;
             }
-            return true;
         }
         return false;
 
diff --git a/src/main/java/net/minecraft/core/item/PlaceableItem.java b/src/main/java/net/minecraft/core/item/PlaceableItem.java
index 994e9ebc0..9cdf81b84 100644
--- a/src/main/java/net/minecraft/core/item/PlaceableItem.java
+++ b/src/main/java/net/minecraft/core/item/PlaceableItem.java
@@ -1,14 +1,11 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
-
 public class PlaceableItem extends Item {
 	
 	public Block blockToPlace;
@@ -30,21 +27,15 @@ public class PlaceableItem extends Item {
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
 		}
-		Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-		boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
-
 		if(blockY < 0 || blockY >= world.getHeightBlocks()) {
 			return false;
 		}
 		if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
-			if (placedInside && !world.isClientSide){
-				world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
-			}
 			if(world.setBlockWithNotify(blockX, blockY, blockZ, blockToPlace.id)) {
 				blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
+				return true;
 			}
-			return true;
 		}
 		return false;
 	}
diff --git a/src/main/java/net/minecraft/core/item/RopeItem.java b/src/main/java/net/minecraft/core/item/RopeItem.java
index f3dd0d599..afb078b92 100644
--- a/src/main/java/net/minecraft/core/item/RopeItem.java
+++ b/src/main/java/net/minecraft/core/item/RopeItem.java
@@ -1,14 +1,11 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
-
 public class RopeItem extends PlaceableItem {
     public RopeItem(String name, String namespaceId, int id, Block blockToPlace) {
         super(name, namespaceId, id, blockToPlace);
@@ -38,21 +35,15 @@ public class RopeItem extends PlaceableItem {
             blockY += side.getOffsetY();
             blockZ += side.getOffsetZ();
         }
-        Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-        boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
-
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
             return false;
         }
         if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
-            if (placedInside && !world.isClientSide){
-                world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
-            }
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? 0b1000_0000 : 0)) {
                 blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
+				return true;
             }
-            return true;
         }
         return false;
     }
